/*
1. Editar precio por kilo
2. Eliminar el producto pero que no afecte capital registros de venta y compra
   y generar una nueva tabla producto existencia precio y motivo
3. Cambiar las alertas por un componente de html
4. Encontrar errores posibles y solucionarlos
   **Al comprar la cantidad o el precio exedian el capital 
     la exitencia se incrementaba, numeros negativos y valores de texto o numericos donde no corresponden
*/

let cash = _cashier(db_cash);
let products = _products(db_productos);
let purchase = _purchase(db_purchase);
let sales = _sales(db_sales);
let remove = _remove(db_remove);

let error = document.getElementById("error");
let exito = document.getElementById("exito");


const getCash = () => {
	let cashTetxt = document.getElementById('cash');
	cashTetxt.innerHTML = `Capital ${cash.getStored()} MXN`;
}

const buidTable = (db_productos) => {
	let table = document.getElementById("productsTable");
	let lista = table.getElementsByTagName("tbody")[0];
	lista.innerHTML = "";

	products.getAllProducts().forEach((element) => {
		let row = document.createElement("tr");
		const sellButton = `sale-${element.id}`;
		const purchaseButton = `purchase-${element.id}`;

		const editarPrecioButton = `editar-${element.id}`;
		const deleteButton = `delete-${element.id}`;

		row.innerHTML = ` 
			<th scope="row">${element.id}</th>
			<td>${element.name}</td>
			<td>${element.stored}</td>
			<td>${element.price}</td>
			<td> <button type="button" class="btn btn-primary" id="${sellButton}"> Vender </button> </td>
			<td> <button type="button" class="btn btn-secondary" id="${purchaseButton}"> Comprar </button> </td>
			<td> <button type="button" class="btn btn-info" id="${editarPrecioButton}"> Editar Precio </button> </td>
			<td> <button type="button" class="btn btn-danger" id="${deleteButton}"> Eliminar </button> </td>
			<td></td>

		`;

		lista.appendChild(row);
		document.getElementById(sellButton).addEventListener('click', (e) => {
			sellButtonEvent(element.id);

		});

		document.getElementById(purchaseButton).addEventListener('click', (e) => {
			purchaseButtonEvent(element.id);
		});

		document.getElementById(editarPrecioButton).addEventListener('click', (e) => {
			editarPrecioEvent(element.id);
		});

		document.getElementById(deleteButton).addEventListener('click', (e) => {
			deleteProductEvent(element.id);
		});
		
	});
	
};

const editarPrecioEvent = (id) => {
	let container = document.getElementById("editarContainer");
	let product = products.getProducts(id);

	container.innerHTML = `
	<div class="container"> 
		<h1> Editar Precio </h1>
	 </div> 

	<div class="col"> 
		<h5> ${product.name} </h5>
	 </div>

	 <div class="col"> 
		<h5> Precio Actual </h5>
		${product.price}
	 </div>

	 <div class="col"> 
		<h5>Nuevo Precio</h5>
		<input type="text" class="form-control" id="editarItem">
		
	<br>
		<button type="button" class="btn btn-success" id="btnEditarItem">Actualizar</button>
		<button type="button" class="btn btn-danger" id="cancelarEditar">Cancelar</button>
	 </div>

	 `;

	 document.getElementById("btnEditarItem").addEventListener("click", (e) => { 
	 const price = document.getElementById("editarItem").value;
	 const alerta = document.getElementById("alertaTexto");
	 
		 if( price <= 0 || isNaN(price)){
		 	error.style.display = "block";
		 	error.textContent = "Valor no permitido";
		 	document.getElementById("editarItem").style.borderColor = "#FF0000";

		 }else{
		 	error.style.display = "none";
		 	editarPrecioAction(product.id, new Number(price));
		 }
	});

	 document.getElementById("cancelarEditar").addEventListener("click", cancelOp);

}

const editarPrecioAction = (id, price) => {		 	
	try{
		products.editar(id, price);		
		exito.style.display = "block";
		exito.textContent = "Cambio realizado";

		setTimeout(function() {
			exito.style.display = "none";
		}, 2000);
		
	}
	catch(err){
		error.style.display = "block";
		error.textContent = err.error;

		setTimeout(function() {
			error.style.display = "none";
		}, 2000);
	}

	buidTable();
	cancelOp();
	
};

const deleteProductEvent = (id) => {
	let container = document.getElementById("deleteContainer");
	let product = products.getProducts(id);

	container.innerHTML = ` 
	<div class="container"> 
		<h1> Eliminar Producto </h1>
	 </div> 

	<div class="col"> 
		<h5> ${product.id} </h5>
	 </div>

	<div class="col"> 
		<h5> ${product.name} </h5>
	 </div>

	<div class="col"> 
		<h5>Razon </h5>
		<textarea class="form-control" id="razon" ></textarea>		
	<br>
		<button type="button" class="btn btn-success" id="btnDeleteItem">Eliminar</button>
		<button type="button" class="btn btn-danger" id="cancelar">Cancelar</button>
	 </div>
	 `;

	 document.getElementById("btnDeleteItem").addEventListener("click", (e) => { 
	 const razon = document.getElementById("razon").value;

		if( razon == "" || !isNaN(razon) ){	 	
		 	error.style.display = "block";
		 	error.textContent = "Especifique una razon";
		 	document.getElementById("razon").style.borderColor = "#FF0000";

	 	}else{ 
		 	error.style.display = "none";
		 	deleteAction(product.id, product.name, product.stored, product.price, razon);

	 	}
	});

	 document.getElementById("cancelar").addEventListener("click", cancelOp);

}

const deleteAction = (id, name, stored, price, razon) => {
	try{
		products.delete(id);
		remove.new(id, name, stored, price, razon);

		exito.style.display = "block";
	 	exito.textContent = "Producto Eliminado";

		setTimeout( () => {
	 		exito.style.display = "none";
	 	}, 2000);
		
		
	}
	catch(err){		
		error.style.display = "block";
		error.textContent = err.error;

		setTimeout( () => {
			error.style.display = "none";
		}, 2000);
	}

	buidTable();
	deleteTable();
	cancelOp();
}

const deleteTable = () => {
	let table = document.getElementById("deleteTable");
	let lista = table.getElementsByTagName("tbody")[0];
	lista.innerHTML = "";

	remove.deleteAll().forEach((element) => {
		let row = document.createElement("tr");
		
		row.innerHTML = ` 
			<th scope="row">${element.producId}</th>
			<td>${element.name}</td>
			<td>${element.stored}</td>
			<td>${element.price}</td>
			<td>${element.motivo}</td>
			<td></td>			
		`;

		lista.appendChild(row);
	});

}

const builSaleTable = () => {
	let table = document.getElementById("salesTable");
	let lista = table.getElementsByTagName("tbody")[0];
	lista.innerHTML = "";

	sales.getAllSales().forEach((element) => {
		let row = document.createElement("tr");
		let date = moment(element.date);

		row.innerHTML = ` 
			<th scope="row">${element.producId}</th>
			<td>${date.format('LLLL')}</td>
			<td>${element.quantity}</td>
			<td>${element.totalPrice}</td>
		`;

		lista.appendChild(row);
	});
}

const builPurchaseTable = () => {
	let table = document.getElementById("purchaseTable");
	let lista = table.getElementsByTagName("tbody")[0];
	lista.innerHTML = "";

	purchase.getAllPurcheses().forEach((element) => {
		let row = document.createElement("tr");
		let date = moment(element.date);

		row.innerHTML = ` 
			<th scope="row">${element.producId}</th>
			<td>${date.format('LLLL')}</td>
			<td>${element.quantity}</td>
			<td>${element.price}</td>
			<td>${element.totalPrice}</td>
		`;

		lista.appendChild(row);
	});
}

const sellButtonEvent = (id) => {
	let container = document.getElementById("sellContainer");
	let product = products.getProducts(id);

	container.innerHTML = ` 	
	<div class="container"> 
		<h1> Venta </h1>
	 </div>
	
	<div class="col"> 
		<h5> ${product.name} </h5>
	 </div>

	 <div class="col"> 
		<h5> Existencias ${product.stored} </h5>
	 </div>

	 <div class="col"> 
		<h5>Cantidad a vender (kg) </h5>
		<input type="text" class="form-control" id="sellItem">		

		<br>
		<button type="button" class="btn btn-success" id="btnSellItem">Vender</button>	
		<button type="button" class="btn btn-danger" id="cancelSell">Cancelar</button>
	 </div>

	 `;

	 document.getElementById("btnSellItem").addEventListener("click", (e) => {
	 	const amount = document.getElementById("sellItem").value;	 	

	 	if( (amount < 0) || ( isNaN(amount)) ) {	
	 		error.style.display = "block";
	 		error.textContent = "Valor no permitido";
	 		document.getElementById("sellItem").style.borderColor = "#FE0000";

 		}else{ 
 		error.style.display = "none";
 		sellProductAction(product, new Number(amount));	 		

 		}

	 });

	 document.getElementById("cancelSell").addEventListener("click", cancelOp);

}

const purchaseButtonEvent = (id) => {
	let container = document.getElementById("purchaseContainer");
	let product = products.getProducts(id);

	container.innerHTML = ` 
	<div class="container"> 
		<h1> Compras </h1>
	 </div> 

	<div class="col"> 
		<h5> ${product.name} </h5>
	 </div>

	 <div class="col"> 
		<h5> Existencias ${product.stored} </h5>
	 </div>

	 <div class="col"> 
		<label>Cantidad a comprar (kg) </label>
		<input type="text" class="form-control" id="purchaseItem">

		<label>Precio de compra (kg) </label>
		<input type="text" class="form-control" id="purchasePrice">
		<br>
		<button type="button" class="btn btn-success" id="btnPurcheseItem">Comprar</button>
		<button type="button" class="btn btn-danger" id="cancelPurchase">Cancelar</button>
	 </div>

	 `;

	 document.getElementById("btnPurcheseItem").addEventListener("click", (e) => {
	 	const amount = document.getElementById("purchaseItem").value;
	 	const price = document.getElementById("purchasePrice").value;


	 	if( amount < 0 || isNaN(amount) ) {	
	 		console.log("error");
	 			document.getElementById("purchaseItem").style.borderColor = "#FF0000";	 
	 			document.getElementById("purchasePrice").style.borderColor = "#ced4da";				
		 		error.style.display = "block";
		 		error.textContent = "Valor no permitido";

	 		}else if( price < 0 || isNaN(price) ){ 
	 			document.getElementById("purchasePrice").style.borderColor = "#FF0000";
	 			document.getElementById("purchaseItem").style.borderColor = "#ced4da";	 	 			
		 		error.style.display = "block";
		 		error.textContent = "Valor no permitido";

		 		}else{
			 		error.style.display = "none";
			 		purchaseProductAction(product, new Number(amount), new Number(price));
		 		}
	 });

	 document.getElementById("cancelPurchase").addEventListener("click", cancelOp);
}

const sellProductAction = (product, amount) => {
	
	try{
		const totalSale = amount * product.price;
		products.sale(product.id, amount);
		cash.sale(totalSale);
		sales.new(product.id, amount, product.price);

		exito.style.display = "block";
		exito.textContent = "Venta exitosa";

		setTimeout( () =>{
			exito.style.display = "none";
		}, 2000);

	}
	catch(err){		
		error.style.display = "block";
		error.textContent = err.error;

		setTimeout( () => {
			error.style.display = "none";
		}, 2000);
		
	}

	buidTable();
	getCash();
	builSaleTable();
	cancelOp();
}

const purchaseProductAction = (product, amount, price) => {
	try{
		const total = price * amount;

		total > cash.getStored() ? 
			cash.purchase(total) 
			: 
			cash.purchase(total);			
			products.purchase(product.id, amount);
			purchase.new(product.id, amount, price);
			exito.style.display = "block";
			exito.textContent = "Compra exitosa";

			setTimeout( () => {
				exito.style.display = "none";
			}, 2000);
		}

	catch(err){			
		error.style.display = "block";
		error.textContent = err.error;

		setTimeout( () => {
			error.style.display = "none";
		}, 2000);
	}

	buidTable();
	getCash();
	builPurchaseTable();	

	cancelOp();
};

const cancelOp = () => {
	document.getElementById("sellContainer").innerHTML = "";
	document.getElementById("purchaseContainer").innerHTML = "";
	document.getElementById("editarContainer").innerHTML = "";
	document.getElementById("deleteContainer").innerHTML = "";
	setTimeout( () => {
			error.style.display = "none";
		}, 1000);
	
}

const newProductEvent = () => {
	const name = document.getElementById('np_name').value;
	const stored = new Number(document.getElementById('np_stored').value);
	const purchasePrice = new Number(document.getElementById('np_p_price').value);
	const salePrice = new Number(document.getElementById('np_s_price').value);

	if( name == "" || !isNaN(name) ){
		error.style.display = "block";
		error.textContent = "Nombre incorrecto";
	 	document.getElementById("np_name").style.borderColor = "#FF0000";
	
		}else if(stored < 0 || isNaN(stored) ) { 
				document.getElementById("np_name").style.borderColor = "#ced4da";
				error.style.display = "block";
				error.textContent = "Valor incorrecto";	
				document.getElementById("np_stored").style.borderColor = "#FF0000";

			}else if(purchasePrice < 0 || isNaN(purchasePrice) ) { 
				document.getElementById("np_stored").style.borderColor = "#ced4da";
				error.style.display = "block";
				error.textContent = "Valor incorrecto";	
				document.getElementById("np_p_price").style.borderColor = "#FF0000";


				}else if(salePrice < 0 || isNaN(salePrice) ) { 
					document.getElementById("np_name").style.borderColor = "#ced4da";
					document.getElementById("np_stored").style.borderColor = "#ced4da";
					document.getElementById("np_p_price").style.borderColor = "#ced4da";
					error.textContent = "Valor incorrecto";	
					error.style.display = "block";
					document.getElementById("np_s_price").style.borderColor = "#FF0000";

					}else{ 						
						document.getElementById("np_s_price").style.borderColor = "#ced4da";
						error.style.display = "none";
											

						try{
							cash.purchase(stored * purchasePrice);
							const newProd = products.newProduct(name, stored, salePrice);
							purchase.new(newProd.id, stored, purchasePrice);

							exito.style.display = "block";
							exito.textContent = "Producto Añadido Correctamente";

							setTimeout( () => {
								exito.style.display = "none";
							}, 2000)
						}
						catch(err){
							error.style.display = "block";
							error.textContent = err.error;	
							setTimeout( () => {
								error.style.display = "none";
							}, 2000);
						}	

						buidTable();
						getCash();				

						document.getElementById("addProduct").reset();
						addProductEventEnd();
					}			
}

const submitEvent = (e) => {
	e.preventDefault();

		switch(e.target.id){
			case 'addProduct':
				 newProductEvent();
				 break;

			default:
				break;
		}

}

const addProductEventStart = () => {
	document.getElementById('addProduct').style.display = "block";
	document.getElementById('addProductBtn').style.display = "none";
}

const addProductEventEnd = () => {
	document.getElementById('addProduct').reset();
	document.getElementById('addProduct').style.display = "none";
	document.getElementById('addProductBtn').style.display = "block";
	document.getElementById("np_name").style.borderColor = "#ced4da";
	document.getElementById("np_stored").style.borderColor = "#ced4da";
	document.getElementById("np_p_price").style.borderColor = "#ced4da";
	document.getElementById("np_s_price").style.borderColor = "#ced4da";
	setTimeout( () => {
		error.style.display = "none";
	}, 500);
}

addEventListener('load', getCash);
addEventListener('load', buidTable);
addEventListener('load', builSaleTable);
addEventListener('load', builPurchaseTable);
addEventListener('load', deleteTable);
addEventListener('submit', submitEvent);
document.getElementById("addProductBtn").addEventListener('click', addProductEventStart);
document.getElementById("cancelNewProd").addEventListener('click', addProductEventEnd);