const _cashier = (start) => {
	let cash = start;

	return {
		sale: (total) => {
			cash += total;

		},

		purchase: (total) => {
			if(total < cash){
				cash -= total;				

			}else{				
				throw{error: "Fondos insuficientes"}
			}
		},

		getStored: () => {
			return cash;
		}
	}
};

const _products = (start) => {
	let products = start;

	return {

		total: (total) => {
			return total;
		},

		sale: (id, amount) => {
			const index = products.findIndex((item) => item.id === id);
			if( index > -1 ){
				if(products[index].stored >= amount){
					products[index].stored -= amount;
				
				}else{
					throw{ error: "No se puede vender poca existencia" };
				}
			
			}else{
				throw{ error: "Producto no encontrado" };
			}
		},

		purchase: (id, amount) => {
			const index = products.findIndex((item) => item.id === id);
			
			if( index > -1 ){
			
				products[index].stored += amount;	

			}else{
				throw { error: "Producto no encontrado" };
			}
		},

		getAllProducts: () => {
			return products;
		},

		getProducts: (id) => {
			const index = products.findIndex( (item) => item.id === id);
			return products[index];
		},
		
		newProduct: (name, stored, price) => {
			const lastProduct = products[products.length -1];
			const newProd = {
				id: lastProduct.id + 1, 
				name: name, 
				stored: stored, 
				price: price
			};

			products.push(newProd);
			return newProd;
		},

		editar: (id, price) => {			
			const index = products.findIndex((item) => item.id === id);	

				if( index > -1 ){
				products[index].price = price;

			}else{
				throw { error: "Producto no encontrado" };
			}						
		},

		delete: (id) => {
				const index = products.findIndex((item) => item.id === id);				

				products.splice(index,1);
		},

	}
};

const _sales = (start) => {
	let sales = start;

	return{
		new: (id, quantity, price) => {
			sales.push({
				producId: id,
				date: new Date(),
				quantity: quantity,
				totalPrice: quantity * price
				});
		},
		getAllSales: () => {
			return sales
		}
	}
};

const _purchase = (start) => {
	let purchases = start;

	return{
		new: (id, quantity, price) => {
			purchases.push({
				producId: id,
				date: new Date(),
				quantity: quantity,
				totalPrice: quantity * price,
				price: price
				});
		},
		getAllPurcheses: () => {
			return purchases
		}
	}
};

const _remove = (start) => {
	let remove = start;
	return{
		new: (id, name, stored, price, motivo) => {
		
			remove.push({
				producId: id,
				name: name,
				stored: stored,
				price: price,
				motivo: motivo
				});
		},
		deleteAll: () => {
			return remove
		}
	}
};


